﻿/*
 * Copyright (c) 2013 CodingBlocks.NET <http://codingblocks.net>, Michael Outlaw <michael@michaeloutlaw.com>
 * 
 * See the file license.txt for copying permission.
 */

using System;

namespace BadEIMIExamples
{
    public class SomeChildClass : SomeClass, IComparable
    {
        // Well this can be confusing.
        // Notice that this is not declared with the override keyword
        public int CompareTo(object obj)
        {
            Console.WriteLine("SomeChildClass IComparable.CompareTo.");
            if (obj == null) return 1;

            var sc = obj as SomeChildClass;
            if (sc != null)
            {
                return SomeData.CompareTo(sc.SomeData) * -1;
            }
            else
            {
                throw new ArgumentException("Oops! That's not SomeChildClass!?");
            }
        }
    }
}
